#!/usr/bin/perl
# trim_o_tax_act2dat.pl:  Merge O_TAX__.NEW and the original TRIM TAX data 
# It writes O_TAX__.DA_ the finished file, and erases the NEW file.
my $o_file="";
my $m_file="";
my $merge_file="O_TAX___.NEW";		# (USPS) corrected address File
my $original_file="O_TAX___.DAT";		# original merge 
my $dest_file="O_TAX___.DA_";		# destination file
my $headerbytes=128;
my $DAT_Seg1=67;
my $ACT_Seg2=132;
my $DAT_Seg3=373;
my $reclen=572;						# total size of record
my $work_str="";
my $no_t_str="";
my $t_str="";
my $count=0;
my $ii=0;
my $seg1 = "";
my $seg2 = "";
my $seg3 = "";
my $seg_junk = "";

MAIN:
{
	print "*** Opening files ***\n";
	open(original_text,"<$original_file") || die("Cannot Open File: $!\n");
	open(dest_text,">$dest_file") || die("Cannot Open File: $!");
	$o_file = <original_text>;
	$o_file =~ s/(.{$headerbytes})//;
	print dest_text $1;				# write the header
	print "*** Wrote Header ***\n";
# eof header
	open(merge_text,"<$merge_file") || die("Cannot Open File: $!\n");    
	$m_file = <merge_text>;
    while ( $m_file )
    {								# wade across merge file
      $m_file =~ s/(.{$ACT_Seg2})//;# bite off a record $ACT_Seg2 long
      $seg2 = $1;	    			# snag $1 from search ()'s above, it's a record
      $o_file =~ s/(.{$reclen})//;  # bite off a record $reclen long
      $work_str = $1;
      ( $seg1, $seg_junk,$seg3 ) = unpack("A$DAT_Seg1,A$ACT_Seg2,A$DAT_Seg3",$work_str);
      print dest_text $seg1,$seg2,$seg3; 	# write the record 
      print ".";					#,$seg1,$seg2,$seg3; 	
    }
	close(original_text);
   	close(merge_text);				#read original & close it
    close(dest_text);
}
