#!/usr/bin/perl
# trim_o_bill_spl2dat.pl:  Merge O-SWAD__.NEW and the original TRIM BILL Print Spool file data
# It writes nnnnn.spl_, the finished file, and erases the NEW file.
my $o_file="";
my $m_file="";
my $merge_file="O-SWAD__.NEW";		#
my $original_file="000007.spl";		# original print job capture from TRIM
my $dest_file="00007.spl_";			# destination file
my $headerbytes=648;				# temp FOR TESTING ONLY!!!!  Comment THIS OUT
# my $headerbytes=128;
my $work_str="";
my $count=0;
my $ii=0;
my $seg1 = "";
my $seg2 = "";
my $seg3 = "";
my $seg_junk = "";





my $DAT_Seg1=16;
my $ACT_Seg2=132;
my $DAT_Seg3=372;
my $reclen=520;		 				# total size of record






MAIN:
{
	print "*** Opening files ***\n";
	open(original_text,"<$original_file") || die("Cannot Open File: $!\n");
	open(dest_text,">$dest_file") || die("Cannot Open File: $!");
	$o_file = <original_text>;
	$o_file =~ s/(.{$headerbytes})//;
	print dest_text $1;				# write the header
	print "*** Wrote Header ***\n";
# eof header
	open(merge_text,"<$merge_file") || die("Cannot Open File: $!\n");
	$m_file = <merge_text>;
    while ( $m_file )
    {								# wade across merge file
      $m_file =~ s/(.{$ACT_Seg2})//;# bite off a record $ACT_Seg2 long
      $seg2 = $1;	    			# snag $1 from search ()'s above, it's a record

      $o_file =~ s/(.{$reclen})//;  # bite off a record $reclen long

      $work_str = $1;
      ( $seg1, $seg_junk,$seg3 ) = unpack("a$DAT_Seg1,a$ACT_Seg2,a$DAT_Seg3",$work_str);
      print dest_text $seg1,$seg2,$seg3; 	# write the record
      print "."; 					#,$seg1,$seg2,$seg3;
#      print ",,,$seg_junk,,,\n,,,$seg2,,,\n";
    }
	close(original_text);
   	close(merge_text);				#read original & close it
    close(dest_text);
}
