***************************************************
Procedure Dlq2PVA_Tax
***************************************************
priv da,db,dc,dd

clear
text


	This procedure finds PVA records for delinquent Solid Waste Customers.  It 
	reports the PVA account info and the Solid Waste account info together and 
	shows what changes would be made to a tax bill to list the delinquent charges.
	
	It also creates the line to be "stuffed"  into the bill.
	
	When prompted below, enter the path to the current Solid Waste ACT Accounts,
	(like F:\LSW04).

endtext

use got_letters excl
zap
appe from i:\letcher_delinquent_sw_1.txt type sdf
appe from i:\letcher_delinquent_sw_2.txt type sdf
appe from i:\letcher_delinquent_sw_BILLS.txt type sdf
dele all for  len(alltrim(pickup_id))=0
pack
repl all compound with upper(alltrim(compound))
set filter to left(compound,1)=chr(9)
repl all compound with substr(compound,2)
set filter to

use act_dlq
zap
appe from act_cust

					? [Cull by compound field <<=======]
					REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
						RIGHT(ALLTRIM(fname),3)+LEFT(STREET,10)+;
						LEFT(city,4)+ALLTRIM(zip)
					INDE ON compound TAG compound
					
store [set defa to ]sys(5)+sys(2003) to dd        && orig defa in dd				
store [k:\act_whi]	to da
acce {Enter the directory to the current Solid Waste ACT Accounts (like f:\lsw04]) to da
store [set defa to ]+alltrim(upper(da)) to db
&db                           && set 
text					


					REPL ALL lname WITH ALLTRIM(UPPER(lname)),;
					 fname WITH ALLTRIM(UPPER(fname)),;
					  STREET WITH ALLTRIM(UPPER(STREET)),;
					   city WITH ALLTRIM(UPPER(city)),;
					    st WITH ALLTRIM(UPPER(st))
					    
					    
					    
					    

					GOTO BOTTOM
					DO WHILE ( .NOT. BOF())
						STORE ALLTRIM(lname)+LEFT(fname,3)+;
							RIGHT(ALLTRIM(fname),3)+LEFT(STREET,10)+;
							LEFT(city,4)+ALLTRIM(zip) TO a_zns
						SKIP -1
						IF BOF()
							EXIT
						ENDIF
						IF ALLTRIM(lname)+LEFT(fname,3)+;
								RIGHT(ALLTRIM(fname),3)+LEFT(STREET,10)+;
								LEFT(city,4)+ALLTRIM(zip)=a_zns  && zap dup street #'s
							SKIP
							REPLACE cust_type WITH [z]
							DELETE NEXT 1
							? RECNO(), [z]
							SKIP -1
						ENDIF
					ENDDO

					GOTO TOP
					COPY ALL FOR DELETED() TO \temp\act_culz.DBF

endtext